
jQuery(document).ready(function() {
  
  jQuery('#header .toggle-mobile-nav').click(function(e) {
    if(jQuery('body').width() > 767) { if(typeof(console) != 'undefined') console.log('Mobile nav launch deferred, viewport does not feel like a mobile device.'); return; }
    e.preventDefault();
    jQuery('body').addClass('popup-fs');
    toggle_popup('show', '<span></span>', function() {
      var $mobile_nav = jQuery('#mobile-nav').clone();
      $mobile_nav.hide().appendTo(jQuery('.popup .popup-content'));
      jQuery('.popup').addClass('has-mobile-nav');
      jQuery('.popup').addClass('slide-to-center');
      $mobile_nav.fadeIn('fast', function() {
        var $nav_items = $mobile_nav.find('ul.mobile-nav-items > li');
        $nav_items.each(function(i, nav_item) {
          setTimeout("jQuery('.popup #mobile-nav ul.mobile-nav-items > *:nth-child("+(i + 1)+")').addClass('show');", i*120);
        });
      });
    });
  });
  jQuery('.popup').click(function(e) {
    if(jQuery(e.target).hasClass('overlay')
    || jQuery(e.target).hasClass('close-popup')
    || jQuery(e.target).is('.popup > div[class*="container"]')
    || jQuery(e.target).is('.popup > div[class*="container"] > .row')
    || jQuery(e.target).is('.popup > div[class*="container"] > .row > div[class*="col-"]')) {
      toggle_popup('hide');
    }
  });
  
  if(typeof(generate_mobile_nav) == 'function')
    generate_mobile_nav();
  
});

function toggle_popup(toggle, content, callback, iframe_load_callback) {
  if(toggle == 'show'
  || toggle == 'loading') {
    /* Set classes */
    jQuery('body').addClass('popup-active');
    if(toggle == 'loading') jQuery('.popup').addClass('loading').find('.popup-content').hide();
    else jQuery('.popup').removeClass('loading');
    
    /* Set .popup.window top offset */
    jQuery('.popup .window').css({ top: jQuery(window).scrollTop() + (jQuery('body').hasClass('vp767') ? 0 : jQuery('#header').height()) });
    
    /* Display .popup */
    jQuery('.popup').fadeIn('fast', function() {
      if(toggle == 'loading') {
        if(typeof(callback) == 'function') callback();
        jQuery('.popup > div[class*="container"]').css('top', jQuery(window).scrollTop());
        if(typeof(content) == 'string'
        && (content.substring(0, 4) == 'http' || content.substring(0, 1) == '/')) {
          jQuery('.popup .popup-content').append(
            '<a href="javascript: void(0)" class="close-popup cross"></a>'
            +'<iframe class="popup-iframe" src="'+content+'"></iframe>');
          var $iframe = jQuery('.popup .popup-content iframe.popup-iframe');
          $iframe
            .load(function() {
              
              /* Execute iframe callback function */
              if(typeof(iframe_load_callback) == 'function') iframe_load_callback();
              
              /* Bind iframe unload function */
              $iframe[0].contentWindow.onbeforeunload = function () { $iframe.closest('.popup').addClass('loading').find('.popup-content').css({ display: 'table', opacity: '1' }).animate({ opacity: '0' }, 'fast', function() { jQuery(this).attr('style', 'display: none'); }); };
              
              /* If iframe content is logged in, refresh parent window */
              if(jQuery(this.contentWindow.document.body).hasClass('logged-in') && !jQuery(this.contentWindow.document.body).hasClass('allow-logged-in-popup')) { window.location.reload(); return; }
              
              /* Set classes and display popup-content */
              jQuery('.popup')
                .removeClass('loading')
                .addClass(jQuery('.popup').hasClass('article') ? '' : 'narrow')
                .find('.popup-content')
                  .css({ display: 'table', opacity: '0' })
                  .animate({ opacity: '1' }, 'fast', function() { jQuery(this).attr('style', 'display: table; height: '+jQuery(this).height()+'px'); });
              
              /* Set .popup-content height */
              jQuery('.popup .popup-content').height($iframe.get(0).contentWindow.document.body.scrollHeight + 20);
              
              /* Set .popup.window top offset */
              var window_height = (jQuery('body').hasClass('template-product') && !isNaN(window.innerHeight)) ? window.innerHeight : jQuery(window).height();
              if(!jQuery('body').hasClass('vp767'))
                jQuery('.popup .window')
                  .css({ top:
                    (jQuery('.popup .popup-content').height() > window_height)
                    ? jQuery(window).scrollTop() + jQuery('#header').height()
                    : jQuery(window).scrollTop() + (window_height/2) - (jQuery('.popup .popup-content').height()/2) });
              
              /* Vertically center iframed .popup.window */
              if(!jQuery('body').hasClass('vp767'))
                jQuery('.popup .window')
                  .addClass('dim-content')/*
                  .css({
                    height: $iframe.get(0).contentWindow.document.body.scrollHeight + 10,
                    marginTop: (-1)*(($iframe.get(0).contentWindow.document.body.scrollHeight + 10)/2)
                  })*/;
              
            }); /* End: $iframe.load */
          } /* End: if content has URL */
        return;
      } /* End: if toggle == loading */
      /* Adding content to popup */
      jQuery(content).appendTo('.popup .popup-content'); /* USING SMARTER CODE
      if(typeof(content) == 'string')
        jQuery('.popup .popup-content').html(content);
      if(typeof(content) == 'object'
      && typeof(content.appendTo) == 'function') {
      	content.appendTo('.popup .popup-content');
      }*/
      /* Set content reference class */
      var $added_content_container = jQuery('.popup .popup-content').find('.close-popup').next();
      if(typeof($added_content_container.attr('id')) != 'undefined') jQuery('.popup').addClass('has-'+$added_content_container.attr('id'));
      /* Display .popup-content */
      jQuery('.popup .popup-content')
        .css({ display: 'table', opacity: '0' })
        .animate({opacity: '1'}, 'fast', function() {
          jQuery(this).attr('style', 'display: table');
          if(typeof(callback) == 'function') callback();
        });
      /* Set .popup.window top offset */
      if(!jQuery('body').hasClass('vp767')) {
        var window_height = (jQuery('body').hasClass('template-product') && !isNaN(window.innerHeight)) ? window.innerHeight : jQuery(window).height();
        jQuery('.popup .window')
        .css({ top:
              (jQuery('.popup .popup-content').height() > window_height)
              ? jQuery(window).scrollTop() + jQuery('#header').height()
              : jQuery(window).scrollTop() + (window_height/2) - (jQuery('.popup .popup-content').height()/2) });
      }
      
    });
  } else {
    var hide_popup = function() {
      jQuery('.popup .popup-content').fadeOut('fast', function() {
        jQuery('.popup .popup-content').attr('style', 'display: none');
        jQuery('.popup').fadeOut('fast', function() {
          jQuery('.popup')
            .attr('class', 'popup product')
            .find('.popup-content').empty().hide();
          jQuery('.popup .window').attr('class', 'window container-fluid').removeAttr('style');
          jQuery('body').removeClass('popup-active popup-fs tall-popup allow-scrolling');
          jQuery('.on-fullscreen').removeClass('on-fullscreen');
          jQuery('.add-to-cart-message-container .add-to-cart-message').animate({ marginTop: '-20px', opacity: '0' }, 'fast', function() { jQuery(this).empty().remove(); });
          jQuery('.popup').removeData('avail_colors_data');
          if(typeof(callback) == 'function') callback();
        });
      });
    },
        $mobile_nav = jQuery('.popup #mobile-nav');
    if($mobile_nav.length > 0) {
      var $nav_items = $mobile_nav.find('ul.mobile-nav-items > li'), nav_item_index;
      $nav_items.each(function(i, nav_item) {
        nav_item_index = i;
        setTimeout("jQuery('.popup #mobile-nav ul.mobile-nav-items > *:nth-child("+(($nav_items.length - i) + 1)+")').addClass('hide');", i*100);
      });
      setTimeout("jQuery('.popup').removeClass('slide-to-center').addClass('slide-to-right'); delay_func(function() { jQuery('.popup #mobile-nav').empty().remove(); toggle_popup('hide'); }, 200);", (++nav_item_index)*100);
    } else hide_popup();
  }
}